_RenderArray = {};
local Keys = {};
local myChainArray = {};
local jumping = false;

function love.load()
	love.physics.setMeter(64) --the height of a meter
	_world = love.physics.newWorld(0, 50*64, true)
	CreateGameObject(400,500,700,50,nil,"static");
	CreateGameObject(50,230,30,500,nil,"static"); -- left wall
	CreateGameObject(750,230,30,500,nil,"static"); -- right wall
	CreateGameObject(400,300,70,10,nil,"static");
	CreateGameObject(300,200,70,10,nil,"static");
	myChainArray[#myChainArray+1] = CreateChain(20,340,100);
	myChainArray[#myChainArray+1] = CreateChain(20,400,10);
	myChainArray[#myChainArray+1] = CreateChain(20,300,10);
	_Joe = CreateGameObject(300,200,20,30,nil,"dynamic");
end

function love.draw()--Rendering Function
	for i=1,#_RenderArray do 
		local ob = _RenderArray[i];
		love.graphics.polygon("line", ob.body:getWorldPoints(ob.shape:getPoints()))
	end
	
	love.graphics.print('FPS: '..love.timer.getFPS(), 7, 5)
end

local count = 0;

function love.update(dt)--This is for time based events
	count = count + 1;
	if(count > 10)then 
		
		count = 0;
	end
	---Update chain
	for a=1, #myChainArray do 
		local arr = myChainArray[a];
		for i=1, #arr do 
			local ob = arr[i];
			local angle = (i/#arr) * math.pi * 2;
			local fx = 300 * math.cos(angle);
			local fy = 300 * math.sin(angle);
			ob.body:applyForce(fx,fy);
		end
	end
	------
	_world:update(dt /2);

	if(Keys["right"] or Keys["d"])then 
		local x,y = _Joe.body:getLinearVelocity();
		_Joe.body:setLinearVelocity(500,y)
	end
	if(Keys["left"] or Keys["a"])then 
		local x,y = _Joe.body:getLinearVelocity();
		_Joe.body:setLinearVelocity(-500,y)
	end
	_Joe.body:setAngularVelocity(0);
	_Joe.body:setAngle(0);

	if(Keys["up"] or Keys["w"])then 
		if(jumping == false)then 
			jumping = true;
			local x,y = _Joe.body:getLinearVelocity();
			_Joe.body:setLinearVelocity(x,-1000)
		end
	end
	if(Keys["up"] == nil and Keys["w"] == nil)then jumping = false end
end

function CreateGameObject(X,Y,W,H,Sprite,Type)
    local ob = {}
    ob.x = X; ob.y = Y;
    ob.sprite = Sprite

    ob.angle = 0;
    ob.scaleX = .2;
    ob.scaleY = .2;

    ob.body = love.physics.newBody(_world, X, Y, Type) --place the body in the center of the world and make it dynamic, so it can move around
    ob.body:setMass(5) --uff, very heavy block at the bottom
    if(Type ~= "static")then
    ob.shape = love.physics.newRectangleShape(0, 0, W, H)
  else
    ob.shape = love.physics.newRectangleShape(0, 0, W, H)
  end
    ob.fixture = love.physics.newFixture(ob.body, ob.shape, 1) --Body, Shape, Density


    ob.fixture:setRestitution(0)
    ob.fixture:setFriction(.1);
    ob.fixture:setDensity(1);

    table.insert(_RenderArray,ob)

    return ob;
end

function CreateChain(n,X,Y)
	X = X or 0;
	Y = Y or 0;
	local W = 10;
	local H = 5;
	local prevBody =nil;
	local firstBody = nil;
	local chainArray = {};
	for i=1,n do 
		--local ob = CreateGameObject(X + i * W,Y,W,H,nil,"dynamic"); --straight line
		local angle = (i/n) * math.pi * 2;
		local radius = 35;
		local ob = CreateGameObject(X + math.cos(angle) * radius,Y + math.sin(angle) * radius,W,H,nil,"dynamic");
		chainArray[#chainArray+1] = ob;
		ob.body:setAngle(angle+math.pi/2);

		if(prevBody ~= nil)then
			--love.physics.newRevoluteJoint( ob.body, prevBody.body, prevBody.body:getX() + W/2, prevBody.body:getY(), false ); -- straight line
			love.physics.newRevoluteJoint( ob.body, prevBody.body, prevBody.body:getX() + math.cos(angle+math.pi/2) * W/2, prevBody.body:getY() + math.sin(angle+math.pi/2) * H/2, false );
		end
		prevBody = ob;
		if(i == 1)then firstBody = ob end
		if(i == n)then 
			prevBody = firstBody;
			love.physics.newRevoluteJoint( ob.body, prevBody.body, prevBody.body:getX() - math.cos(angle+math.pi/2) * W/2, prevBody.body:getY() - math.sin(angle+math.pi/2) * H/2, false );
		end
	end
	return chainArray;
end

function love.keypressed( key, scancode, isrepeat )
	Keys[key] = true;
	
	if key == 'escape' then
--		love.system.vibrate(3)
--		love.event.wait(3)
		
		love.event.quit()
--		love.event.push('quit')
	end
end

function love.keyreleased(key)
	Keys[key] = nil;
end